#!/usr/local/bin/ruby
require "classtree.rb"
require 'kde'
#require "tk"
#require 'gtk'
#include Gtk
#include Gdk
include Kde
#include Fltk
#$walker = ClassTree::new()

class RClassMain < KTMainWindow
def initialize
   @w0 = QWidget.new(self)
   @splitter = KNewPanner.new(@w0,"splitter",KNewPanner::Horizontal,
		KNewPanner::Absolute,self.height() - 80)
   @popup = QPopupMenu.new
   @popup.insertItem("&Qt",1)
   @popup.insertItem("Qg&l",7)
   @popup.insertItem("&Kde",5)
   @popup.insertItem("&Gtk",2)
   @popup.insertItem("&Fltk",3)
   @popup.insertItem("&Tk",4)
   @popup.insertItem("&All",6)
   @popup.insertItemQObj( "&Quit", QApplication::qApp, QSLOT("quit()"), CTRL+Key_Q )
   menuBar.insertItem("&File",@popup)
   @classWindow = RClassView.new(@splitter)
   Qt::connect(menuBar,QSIGNAL("activated(int)"), self, "menuActivated")
   @edit = QMultiLineEdit.new(@splitter)
   @splitter.activate(@classWindow,@edit)
   setView(@w0)
   Qt::connect(@classWindow.signal_mlist,self,"methodSelected")
   Qt::connect(@classWindow.signal_vlist,self,"constSelected")

   catchEvent
   setCaption("Ruby Class Browser")
   statusBar.message( "Ready", 5000 )
end
def menuActivated i
   case i
   when 1
      @classWindow.initialize_classview_qt
   when 2
      @classWindow.initialize_classview_gtk
   when 3
      @classWindow.initialize_classview_fltk
   when 4
      @classWindow.initialize_classview_tk
   when 5
      @classWindow.initialize_classview_kde
   when 6
      @classWindow.initialize_classview_Object
   when 7
      @classWindow.initialize_classview_Qgl
   end
end
def methodSelected str
   if str[0].chr == "-"
      @edit.clear
      @edit.setText("No method selected")
      return
   end
   str1 = "Selected Method is "
   str1 += str + " "
   str1 += " in " + "#{@classWindow.currentClass}"
   @edit.clear
   @edit.setText(str1)
end
def constSelected str
   str1 = str + " in " +  "#{@classWindow.currentClass} = "
   temp1 = eval("#{@classWindow.currentClass}::#{str}")
   str1 += temp1.to_s
   @edit.clear
   @edit.setText(str1)
end
def resizeEvent ev
      @splitter.setSeparatorPos(self.height() - 80)
      @splitter.resize(width,height)
end
end

class RClassView < QWidget
def initialize w
   @split = KNewPanner.new(self,"split2")
   @classview = QListView.new(@split,"classview")
   @classview.addColumn("Ruby Class")
   @classview.setColumnWidthMode(1,QListView::Maximum)
   @classview.setRootIsDecorated( true )

   @w1 = QWidget.new(@split)
   @hblayout = QHBoxLayout.new(@w1)
   @vblayout1 = QVBoxLayout.new()
   @hblayout.addLayout(@vblayout1)

   @split.activate(@classview,@w1)
   @mlisthead = QLabel.new("Methods",@w1,"mlisthead")
   @mlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout1.addWidget(@mlisthead)
   @methodlist = QListBox.new(@w1,"methodlist")
   @vblayout1.addWidget(@methodlist)
   @signal_mlist = RSignal.new("const char*")
   Qt::connect(@methodlist,QSIGNAL("selected(const char*)"),
             @signal_mlist)

   @vblayout2 = QVBoxLayout.new()
   @hblayout.addLayout(@vblayout2)

   @varlisthead = QLabel.new("Constants",@w1,"varlisthead")
   @varlisthead.setFrameStyle(QFrame::Panel | QFrame::Raised)
   @vblayout2.addWidget(@varlisthead)
   @varlist = QListBox.new(@w1,"varlist")
   @vblayout2.addWidget(@varlist)
   @signal_vlist = RSignal.new("const char*")
   Qt::connect(@varlist,QSIGNAL("selected(const char*)"),
            @signal_vlist)

   newheight = @classview.header.height - 10
   @mlisthead.setFixedHeight(newheight)
   @varlisthead.setFixedHeight(newheight)


   @hblayout.activate

   initialize_classview_kde
   Qt::connect(@classview,QSIGNAL("selectionChanged()"),self,"cb_select")

   catchEvent


end
def resizeEvent ev
   @split.resize(width,height)
end

def signal_mlist
   @signal_mlist
end
def signal_vlist
   @signal_vlist
end
def currentClass
   @classview.currentItem.text(0)
end
def currentMethod
   @methodlist.text(@methodlist.currentItem)
end
def currentConst
   @varlist.text(@varlist.currentItem)
end
def resizeEvent ev
   @split.resize(width,height)
end

def initialize_classview_qt
   @classview.clear
   @classtree = ClassTree.new(["Qt"])
   @classtree.createTree(@classview)
   #$walker.clear
   #$walker.visit(initialize_args({"qt" => ["Qt"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end

def initialize_classview_gtk
   @classview.clear
   require "gtk"
   @classtree = ClassTree.new(["Gtk","Gdk","GdkImlib"])
   @classtree.createTree(@classview)
   #$walker.clear
   #$walker.visit(initialize_args({"gtk" => ["Gtk","Gdk","GdkImlib"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_fltk
   @classview.clear
   require "fltk"
   @classtree = ClassTree.new(["Fltk"])
   @classtree.createTree(@classview)   #$walker.clear
   #$walker.visit(initialize_args({"fltk" => ["Fltk"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_tk
   @classview.clear
   require "tk"
   @classtree = ClassTree.new(["TkKernel","Tk"])
   @classtree.createTree(@classview)   #$walker.clear
   #$walker.clear
   #$walker.visit(initialize_args({"tk" => ["Tk"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_kde
   @classview.clear
   @classtree = ClassTree.new(["Qt", "Kde"])
   @classtree.createTree(@classview)
   #$walker.clear
   #$walker.visit(initialize_args({"kde" => ["Kde"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end
def initialize_classview_Object
   @classview.clear
   @classtree = ClassTree.new(["Object"])
   @classtree.createTree(@classview)
   #$walker.clear
   #$walker.visit(initialize_args({"kde" => ["Kde"]}))
   #$walker.createDescendantsTree(@classview)
   #$walker.createConstantsList(@varlist,nil)
   #$walker.createMethodsList(@methodlist, nil)
end

def initialize_classview_Qgl
   @classview.clear
   require "qgl"
   require "opengl"
   require "glut"
   @classtree = ClassTree.new(["Qgl","GL","GLU","GLUT"])
   @classtree.createTree(@classview)
end

def cb_select
   cname = @classview.currentItem.text(0)
   @classtree.changeConstants(@varlist,cname)
   @varlisthead.setText("Constants:" + cname)
   @classtree.changeMethods(@methodlist,cname)
   @mlisthead.setText("Methods:" + cname)
   #$walker.changeConstants(@varlist,cls)
   #$walker.changeMethods(@methodlist,cls)
end
end


a = KApplication.new( [$0] + ARGV)
#QApplication::setStyle(Qt::WindowsStyle)
w = RClassMain.new
a.setMainWidget(w)

w.show
a.exec

