#!/usr/local/bin/ruby

require "kde"
include Kde

class KWMain < QWidget
def initialize
  self.resize(370,270)
  self.setMinimumSize(0,0)
  @btnQuit= QPushButton.new("",self,"NoName")
  @btnQuit.setGeometry(260,230,100,30)
  @btnQuit.setMinimumSize(0,0)
  @btnQuit.setText(i18n("Quit"))

  @kColorButton_1= KColorButton.new(QColor("black"),self,"NoName")
  @kColorButton_1.setGeometry(10,10,40,30)
  @kColorButton_1.setMinimumSize(0,0)
  @kColorButton_1.setText(i18n("Button"))

  @kKeyButton_1= KKeyButton.new("NoName",self)
  @kKeyButton_1.setGeometry(10,50,81,34)
  @kKeyButton_1.setMinimumSize(0,0)
  @kRestrictedLine_1= KRestrictedLine.new(self,"NoName")
  @kRestrictedLine_1.setGeometry(110,10,250,30)
  @kRestrictedLine_1.setMinimumSize(0,0)
  @kProgress_1= KProgress.new(0,100,0,KProgress::Horizontal,self,"NoName")
  @kProgress_1.setGeometry(110,50,250,30)
  @kProgress_1.setMinimumSize(0,0)
  @kColorButton_2= KColorButton.new(QColor("black"),self,"NoName")
  @kColorButton_2.setGeometry(60,10,40,30)
  @kColorButton_2.setMinimumSize(0,0)
  @kColorButton_2.setText(i18n("Button"))

  @kLedLamp_1= KLedLamp.new(self)
  @kLedLamp_1.setGeometry(110,90,200,30)
  @kLedLamp_1.setMinimumSize(0,0)
  @lw = QWidget.new(self)
  @lw1 = QWidget.new(self)
  @kLed_1 = KLed.new(KLed::Red,@lw,"")
  @kLed_2 = KLed.new(KLed::Yellow,@lw1,"")
  @lw.setGeometry(300,90,30,30)
  @lw1.setGeometry(330,90,30,30)
  @kLed_1.setState(KLed::On)

  @e = QMultiLineEdit.new(self)
  @e.setGeometry(170,130,190,90)
  @e.setMinimumSize(0,0)

  #//KTreeList_1= KTreeList.new(self,"NoName")
  #//KTreeList_1.setGeometry(170,130,190,90)
  #//KTreeList_1.setMinimumSize(0,0)
  @kDatePicker_1= KDatePicker.new(self)
  @kDatePicker_1.setGeometry(10,130,150,130)
  @kDatePicker_1.setMinimumSize(0,0)

  @date = QDate::currentDate
  Qt::connect(@kDatePicker_1,QSIGNAL("dateSelected(QDate)"),self, "setDate")

  @btnSetDay= QPushButton.new("",self,"NoName")
  @btnSetDay.setGeometry(170,230,80,30)
  @btnSetDay.setMinimumSize(0,0)
  @btnSetDay.setText(i18n("Set Day"))
  Qt::connect(@btnSetDay,QSIGNAL("clicked()"),self,"showSetDay")



  @btnStart= QPushButton.new("",self,"NoName")
  @btnStart.setGeometry(10,90,90,30)
  @btnStart.setMinimumSize(0,0)
  @btnStart.setText(i18n("Start!"))

  @kRestrictedLine_1.setValidChars("*1234567890")
  Qt::connect(@kRestrictedLine_1,QSIGNAL("invalidChar (int)"),self,"invalid")
  Qt::connect(@btnQuit,QSIGNAL("clicked()"),KApplication::qApp,QSLOT("quit()"))
  Qt::connect(@btnStart,QSIGNAL("clicked()"),self,"startBar")
  Qt::connect(@kProgress_1,QSIGNAL("percentageChanged(int)"),self,"stopBar")
  catchEvent

end
def showSetDay
    @e.append "date set to #{@date.toString.to_str}"
    @e.setCursorPosition(@e.numLines - 1,0)
end
def setDate d
   if ((d.day != @date.day) or (d.month != @date.month) or (d.year != @date.year))
      @date = QDate.new(d.year,d.month,d.day)
      @e.append "date set to #{@date.toString.to_str}"
      @e.setCursorPosition(@e.numLines - 1,0)
   end
end
def startBar
    startTimer(100)
end
#/** Catch timer event and progress KProgress */
def timerEvent( ev)
#    debug("timerEvent")
    @kProgress_1.advance(2)
    @kLedLamp_1.toggleState()
    @kLed_1.toggleState()
    @kLed_2.toggleState()
end
#/** Stop KProgress if val is 100 */
def stopBar(val)
    if (val >= 100)
        killTimers
        @kProgress_1.setValue(0)
        @kLed_1.setState(KLed::On)
        @kLed_2.setState(KLed::On)
    end
end
#/** Tell user invalid input. */
def invalid( ch)
    QApplication::beep()
    c = QTime::currentTime()
    while (100 >= (c.msecsTo(QTime::currentTime())))
        @kLedLamp_1.setState(KLedLamp::On)
    end
    @kLedLamp_1.setState(KLedLamp::Off)
    @e.append("Only numbers are permitted.")
    @e.setCursorPosition(@e.numLines - 1,0)
end
end
      a = KApplication.new([$0]+ARGV)

#//  KWidgets2 *kwidgets2 = new KWidgets2()
  kwmain = KWMain.new
  a.setMainWidget(kwmain)
  kwmain.show()

  a.exec()

